import 'package:hive/hive.dart';
import 'package:osam/domain/state/base_state.dart';
import 'package:path_provider/path_provider.dart';

class PersistRepository {
  Box<BaseState> _persist;

  Future<void> initPersist(String appName) async {
    Hive.init((await getApplicationDocumentsDirectory()).path);
    _persist ??= await Hive.openBox(appName);
  }

  void saveState<ST extends BaseState>(ST appState) => _persist.put('appState', appState);

  ST restoreState<ST extends BaseState>() => _persist.get('appState');

  void deleteState() => _persist.delete('appState');

  bool get isPersistEnabled => _persist == null ? false : true;
}
